import "eventManager.js";
import "morphingBracelet.js";
import "mobSounds.js";
import "mobItems.js";
import "onHit.js";
import "foodEaten.js";
import "teleportationInvulnerability.js";
import "storeNectar.js";
// import "witchPotion.js"; Currently disabled due to a change in a minecraft update that made this ability not possible anymore :')
import "frogAttack.js";
import "evokerFang.js";
import "ohioSnowball.js";

import { system, world } from "@minecraft/server";
import { mobs } from "morphables.js";

system.events.beforeWatchdogTerminate.subscribe(data => { data.cancel = true; });
system.runInterval(() => {
  for (const player of world.getPlayers()) {
    player.triggerEvent("morph:on_tick");
    for (let i = 0; i < mobs.length; i++) {
      if (player.getComponent("minecraft:variant").value == mobs[i].variant && (mobs[i].condition == undefined ? true : eval(mobs[i].condition.replace(new RegExp("\\bentity\\b","g"), "player")))) {
        if (player.morph != mobs[i]) { player.morph = mobs[i]; };
        break;
      };
    };
    if (player.getComponent("minecraft:variant").value != 0) {
      if (player.nameTag != "") { player.nameTag = ""; };
    } else { if (player.nameTag != player.name) { player.nameTag = player.name; }; };
  };
  for (const player of world.getPlayers({gameMode: "adventure"})) { if (player.gameMode != "adventure") { player.gameMode = "adventure"; player.runCommand("ability @s mayfly false"); }; };
  for (const player of world.getPlayers({gameMode: "creative"})) { if (player.gameMode != "creative") { player.gameMode = "creative"; player.runCommand("ability @s mayfly true"); }; };
  for (const player of world.getPlayers({gameMode: "spectator"})) { if (player.gameMode != "spectator") { player.gameMode = "spectator"; player.runCommand("ability @s mayfly true"); }; };
  for (const player of world.getPlayers({gameMode: "survival"})) { if (player.gameMode != "survival") { player.gameMode = "survival"; player.runCommand("ability @s mayfly false"); }; };
});