import { world } from "@minecraft/server";

world.events.beforeItemUseOn.subscribe(data => {
  const { source } = data;
  const block = source.dimension.getBlock(data.getBlockLocation());
  if ((source.getComponent("minecraft:variant").value == 40 && source.getComponent("minecraft:is_charged")) && (block.typeId == "minecraft:bee_nest" || block.typeId == "minecraft:beehive")) {
    source.triggerEvent("morph:bee_collect_nectar");
    block.setPermutation(block.permutation.withProperty("honey_level", block.permutation.getProperty("honey_level") < 5 ? block.permutation.getProperty("honey_level") + 1 : block.permutation.getProperty("honey_level") + 0));
    world.playSound("block.beehive.enter", { location: block.location });
  };
});